/************************************************************************/
/* LCDѥͥ롼(SH7262)                                    */
/************************************************************************/
#include "cpu.h"
#include "cpu_init.h"
#include "LCDpanel.h"
#include "led.h"
#include "graphics.h"		// ܥեå롼إå

#define VD_VSTART_VALIDDATA_TOP	(18)	// TOP ΰοľץ㥿ߥ
#define VD_VSTART_VALIDDATA_BTM	(281)	// BOTTOM ΰοľץ㥿ߥ
#define VD_HSTART_VALIDDATA	(308)

#define VD_IO_DFLINE		30
#define LCD_VERTICAL_DE_START	1
#define VD_BUF_MARGIN		6
#define VD_DISP_POS_IO_DF	56

extern int	doGetImage;	// RAM žå
extern int	cq_pos_x;
extern int	cq_pos_y;

/****************************************************************
*
****************************************************************/
void cam_init(void)
{
	long	v_sync_start1_top;
	long	v_sync_start1_btm;

	mVIDEO_MODE.video_main_exe = 0;	// ӥåȢ 1Ͽ賫
	mVIDEO_MODE.video_disp_exe = 1;	// ӥåȢ

	mVIDEO_MODE.sel_525625     = 0;
	mVIDEO_MODE.sel_656601     = 0;
	mVIDEO_MODE.sel_exsync     = 0;
	mVIDEO_MODE.endian_disp    = 0;

	mVIDEO_MODE.burst_mode_disp= 1;
	mVIDEO_MODE.inv_cbcr       = 1;
	mVIDEO_MODE.rgb565         = 0;

	mVIDEO_MODE.endian_main    = 0;
	mVIDEO_MODE.video_mode     = 0;	// 0:Ͽ 1:ɽ

	*mVIDEO_TIM_CNT            = 0x00000000;

	mVIDEO_INT_CNT.int_v_en    = 0;
	mVIDEO_INT_CNT.int_uf_en   = 0;
	mVIDEO_INT_CNT.int_of_en   = 0;
	mVIDEO_INT_CNT.v_period    = 0;
	mVIDEO_INT_CNT.f_end       = 0;	// 1եʬν񤭹ߴλơ
					// 0񤭹߽   1񤭹ߴλ
	mVIDEO_INT_CNT.under_flow  = 0;
	mVIDEO_INT_CNT.over_flow   = 0;

	mVIDEO_INT_CNT.int_f_en    = 0;	// 񤭹ߴλ߽ϵĥӥå
					// ɽ⡼ɻ0(Ե) 

	// ͭ
	mVIDEO_SIZE.video_height = HEIGHT * 2;
	mVIDEO_SIZE.video_width  = WIDTH  * 2;

	mVIDEO_VSTART.video_vstart_top = 0x10;	// ͭľϰ 16(0x10)
	mVIDEO_VSTART.video_vstart_btm = 0x117;	//                        279(0x117)

	mVIDEO_HSTART.video_hstart     = 300;	// ͭʿϰ

	mVIDEO_SAVE_NUM.field_save_num = 0;	// ¸եɿ 0:1 1:2

	mVIDEO_IMAGE_CNT.Contrast    = 0x80;
	mVIDEO_IMAGE_CNT.Bright      = 0x80;
	mVIDEO_IMAGE_CNT.CLIP_Y      = 1;
	mVIDEO_IMAGE_CNT.CLIP_C      = 1;
	mVIDEO_IMAGE_CNT.SUB_SCALE_V = 0;
	mVIDEO_IMAGE_CNT.SCALE_V     = 0;	// 1/2
	mVIDEO_IMAGE_CNT.SUB_SCALE_H = 0;
	mVIDEO_IMAGE_CNT.SCALE_H     = 0;	// 1/2

	*mVIDEO_BASEADR      = (ulong)RAM_PAGE5;	// 饤Хåե

	*mVIDEO_LINE_OFFSET  = (WIDTH * sizeof(short));
	*mVIDEO_FIELD_OFFSET = (WIDTH * HEIGHT * sizeof(short));

	// 
	mVIDEO_DISP_SIZE.video_disp_height = HEIGHT;
	mVIDEO_DISP_SIZE.video_disp_width  = WIDTH;

	mSGMODE.ex_sync_mode       = 0;	// 0:⡼(Ͽ) 1:ϤvSYNCƱ
	mSGMODE.rgb565             = 1;	// ̥ӥåڤΤ

	// ѿľƱ楿ߥ1
	v_sync_start1_top =
		VD_VSTART_VALIDDATA_TOP + VD_IO_DFLINE - 
		LCD_VERTICAL_DE_START + (VD_BUF_MARGIN/2) - VD_DISP_POS_IO_DF;

	v_sync_start1_btm =
		VD_VSTART_VALIDDATA_BTM + VD_IO_DFLINE -
		LCD_VERTICAL_DE_START + (VD_BUF_MARGIN/2) - VD_DISP_POS_IO_DF;

	mVIDEO_VSYNC_TIM1.video_vsync_start1_top = v_sync_start1_top;
	mVIDEO_VSYNC_TIM1.video_vsync_start1_btm = v_sync_start1_btm;


	*mVIDEO_VSYNC_TIM2  = 0x00000000;
	*mVIDEO_DISP_HSTART = 0x00000006;
}
/****************************************************************
* LCDѥͥ
****************************************************************/
void LCDpanel_Initialize(void)
{
	cam_init();

	mSYNCNT.rgb_tim      = 1;
	mSYNCNT.vsync_tim    = 1;
	mSYNCNT.hsync_tim    = 1;
	mSYNCNT.de_tim       = 1;
	mSYNCNT.m_disp_tim   = 1;
	mSYNCNT.vsync_type   = 1;
	mSYNCNT.hsync_type   = 1;
	mSYNCNT.de_type      = 0;
	mSYNCNT.m_disp_type  = 0;

	mPANEL_CLKSEL.icken  = 0;
	mPANEL_CLKSEL.icksel = 1;
	mPANEL_CLKSEL.dcdr   = 8;	// 6MHz(48MHz / 8)  6.4MHz(typ)
	mPANEL_CLKSEL.icken  = 1;

	mSYN_SIZE.syn_height         = LCD_VERTICAL_PERIOD;
	mSYN_SIZE.syn_width          = LCD_HORIZONTAL_PERIOD;

	mPANEL_VSYNC_TIM.vsync_start = 0;
	mPANEL_VSYNC_TIM.vsync_end   = LCD_VERTICAL_PULSE_WIDTH;

	mPANEL_HSYNC_TIM.hsync_start = 0;
	mPANEL_HSYNC_TIM.hsync_end   = LCD_HORIZONTAL_PULSE_WIDTH;

	mDE_SIZE.de_height           = LCD_VERTICAL_DISPLAY_PERIOD;
	mDE_SIZE.de_width            = LCD_HORIZONTAL_DISPLAY_PERIOD;

	mDE_START.de_start_v         = LCD_VERTICAL_BACK_PORCH;
	mDE_START.de_start_h         = LCD_HORIZONTAL_BACK_PORCH;

	*mGRA_VSYNC_TIM      = 0;

	//----------------------------------------------
	// եå1 
	//----------------------------------------------
	mGRCMEN1.WE    = 0;
	mGRCMEN1.den   = 1;	// ȥ쥤
	mGRCMEN1.ven   = 1;	// ̥쥤

	mGRCBUSCNT1.burst_mode = 1;
	mGRCBUSCNT1.bus_format = 0;	// RGB565
	mGRCBUSCNT1.endian     = 0;

	*mGROPSADR1        = GRA1_VRAM_BASE;
	mGROPSWH1.gropsh   = GRA1_VERTICAL_SIZE;
	mGROPSWH1.gropsw   = GRA1_HORIZONTAL_SIZE;
	*mGROPSOFST1       = GRA1_HORIZONTAL_SIZE * 2;
	mGROPDPHV1.gropdpv = (LCD_VERTICAL_BACK_PORCH - 1 + GRA1_VERTICAL_POS);
	mGROPDPHV1.gropdph = (LCD_HORIZONTAL_BACK_PORCH - 16 + GRA1_HORIZONTAL_POS);


	*mGROPBASERGB1 = 0x0000FFFF;	// եå
	mGRCMEN1.WE    = 1;		// 쥸ž

	//----------------------------------------------
	// եå2 (饯ɽ˻)
	//----------------------------------------------
	mGRCMEN2.WE    = 0;
	mGRCMEN2.den   = 1;	// ȥ쥤
	mGRCMEN2.ven   = 1;	// ̥쥤

	mGRCBUSCNT2.burst_mode = 0;
	mGRCBUSCNT2.bus_format = 0;	// RGB565
	mGRCBUSCNT2.endian     = 0;

	*mGROPSADR2        = GRA2_VRAM_BASE;
	mGROPSWH2.gropsh   = GRA2_VERTICAL_SIZE;
	mGROPSWH2.gropsw   = GRA2_HORIZONTAL_SIZE;
	*mGROPSOFST2       = GRA2_HORIZONTAL_SIZE * 2;
	mGROPDPHV2.gropdpv = (LCD_VERTICAL_BACK_PORCH - 1 + GRA2_VERTICAL_POS);
	mGROPDPHV2.gropdph = (LCD_HORIZONTAL_BACK_PORCH - 16 + GRA2_HORIZONTAL_POS);


	*mGROPBASERGB2 = 0x00000000;	// եå
	mGRCMEN2.WE    = 1;		// 쥸ž

	//---------------------------------------------------
	// Alpha ֥
	//---------------------------------------------------
	//   ΰ襵
	mGROPEWH1.gropeh = GRA1_VERTICAL_SIZE;
	mGROPEWH1.gropew = GRA1_HORIZONTAL_SIZE;

	//   ΰ賫ϰ
	mGROPEDPHV1.gropedpv = (LCD_VERTICAL_BACK_PORCH - 1 + GRA1_VERTICAL_POS);
	mGROPEDPHV1.gropedph = (LCD_HORIZONTAL_BACK_PORCH - 16 + GRA1_HORIZONTAL_POS);

	mGROPEDPA1.defa  = 0xFF;	// 䤹ȡǻʤ롢
	mGROPEDPA1.acoef = 0;
	mGROPEDPA1.arate = 0;
	mGROPEDPA1.WE    = 0;	// 쥸žԵ
	mGROPEDPA1.ast   = 0;
	mGROPEDPA1.amod  = 0;
	mGROPEDPA1.aen   = 1;

	mGROPEDPA1.WE    = 1;
	//--------------------------------------------------------------------------
	//   ΰ襵
	mGROPEWH2.gropeh = GRA2_VERTICAL_SIZE;
	mGROPEWH2.gropew = GRA2_HORIZONTAL_SIZE;

	//   ΰ賫ϰ
	mGROPEDPHV2.gropedpv = (LCD_VERTICAL_BACK_PORCH - 1 + GRA2_VERTICAL_POS);
	mGROPEDPHV2.gropedph = (LCD_HORIZONTAL_BACK_PORCH - 16 + GRA2_HORIZONTAL_POS);

	mGROPEDPA2.defa  = 0x5F;	// 䤹ȡ̣ǻʤ롢
	mGROPEDPA2.acoef = 0;
	mGROPEDPA2.arate = 0;
	mGROPEDPA2.WE    = 0;	// 쥸žԵ
	mGROPEDPA2.ast   = 0;
	mGROPEDPA2.amod  = 0;
	mGROPEDPA2.aen   = 1;

	mGROPEDPA2.WE    = 1;

}
/****************************************************************
*	Ͽɽ
*	ꥢ륿ǥ餫 LCD ѥ꡼
*	ž롣
*	ؼˤꡢ(doGetImage==1) ѥ꡼ž
****************************************************************/
void	funcFLDE(void)
{
	int	cqx,cqy;
	volatile unsigned long	dummy;

	mVIDEO_INT_CNT.f_end       = 0;	// Field write status clear

	dummy = *xVIDEO_INT_CNT;	// dummy read

	mVIDEO_INT_CNT.int_f_en    = 0;	// not init

	mPFCR2.pf8md               = 0;	// PF8
	mVIDEO_MODE.video_main_exe = 0;
	mSTBCR7.mstp74             = 1;	// VDC3 clock stop
	mPFCR2.pf8md               = 3;	// DV_CLK
	mSTBCR7.mstp74             = 0;	// VDC3 clock start

	dmaTrans_0();

	if(doGetImage==1)
	{
		dmaTrans_1();
		// Ѹн
		bwCnv();
		cq_find(&cqx,&cqy);
		if((cqx > 0)&&(cqy>0))
		{
			cq_pos_x = cqx;
			cq_pos_y = 240-cqy;
		}
		else
		{
			cq_pos_x = -1;
			cq_pos_y = -1;
		}
		doGetImage++;
	}

	mVIDEO_MODE.video_main_exe = 1;
	mVIDEO_INT_CNT.int_f_en    = 1;	// 
}
