#include "TouchPanel.h"
/***************************************************************
	åѥͥ롼
***************************************************************/
// åѥͥѿ
volatile int TOUCH_stat;
volatile int TOUCH_PD;
volatile int TOUCH_nPDcnt;
volatile int TOUCH_Xtmp;
volatile int TOUCH_X;
volatile int TOUCH_Ytmp;
volatile int TOUCH_Y;

/****************************************************************
*
****************************************************************/
void TOUCH_xy(void)
{
	int	x,y;

	// 
	static	int	xl = 90;
	static	int	xh = 925;

	static	int	yl = 95;
	static	int	yh = 740;


	// ɸѴ
	// x ѥ᡼(98 -940)   0-319
	if(TOUCH_Xtmp < xl)
		x=xl;
	else
	{
		if(TOUCH_Xtmp > xh)
			x=xh;
		else
			x=TOUCH_Xtmp;
	}

	if(TOUCH_Ytmp < yl)
		y=yl;
	else
	{
		if(TOUCH_Ytmp > yh)
			y=yh;
		else
			y=TOUCH_Ytmp;
	}

	// ׻
	TOUCH_X = (x - xl) * 320 / (xh - xl);
	TOUCH_Y = (y - yl) * 240 / (yh - yl);
}
/****************************************************************
*
****************************************************************/
void TOUCH_Initialize(void)
{
	TOUCH_stat = 0;
	TOUCH_Xtmp = 0;
	TOUCH_Ytmp = 0;

	mPCCR1.pc7md = 0;	// Y2
	mPCCR1.pc6md = 0;	// X2
	mPCCR1.pc5md = 0;	// Y1

	// ݡPC2 GPIO
	mPCCR0.pc2md = 0;	// X1

	// ڥ󸡽ѥץݡPE3
	*PECR0 = *PECR0  & 0x0FFF;	// GPIO

	// ݡAN0AN1A-DѴݡȤȤѤ
	mPHCR0.ph1md = 1;	// AN1:Y
	mPHCR0.ph0md = 1;	// AN0:X
	mPHCR0.ph2md = 1;	// AN2:X

	TOUCH_AllHiZ();

	TOUCH_X = -1;
	TOUCH_Y = -1;

	// A-DС Х
	mSTBCR3.mstp32 = 0;
}
/****************************************************************
* åѥͥ ڥ󸡽н
****************************************************************/
void TOUCH_PenDownInitialize(void)
{
	*PEIOR0= *PEIOR0 | 0x0008;	// PE3 
	*PEDR0 = *PEDR0  & 0xFFF7;	// PE3 ϥ쥸'L'

	// Y1:PC7='H' Y2:PC5='H'
	*PCDR0 = (*PCDR0 & 0xFF1B) | 0x00A0;

	// Y1:PC7 Y2:PC5  PC6,PC2:input
	*PCIOR0 = (*PCIOR0 & 0xFF1B) | 0x00A0;
}
/****************************************************************
* ϥԡ󥹽
****************************************************************/
void TOUCH_AllHiZ(void)
{
	// [X1:PC2] [X2:PC6] [Y1:PC5] [Y2:PC7] All input
	*PCIOR0 = (*PCIOR0 & 0xFF1B);

}
/****************************************************************
* Xɸ(YIN) A-DѴ
*  0x2000 (AN0)
*  0x2001 (AN1)
*  0x2002 (AN2)
****************************************************************/
void TOUCH_ADstart(ushort ch)
{
	*xADCSR = ch; // ͥ1Ѵ
}
/****************************************************************
* A-DѴ̼
****************************************************************/
ushort	TOUCH_ADin(int ch)
{
	ushort	value;

	while(mADCSR.adst != 0);
	while(mADCSR.adf != 1);

	switch(ch)
	{
		case 0:
			value = *mADDRA;
			break;
		case 1:
			value = *mADDRB;
			break;
		case 2:
			value = *mADDRC;
			break;
		default:
			value = 0;
			break;
	}

	return (value>>6);
}
/****************************************************************
* XɸXŰ 
****************************************************************/
void TOUCH_X1X2(int i)
{
	if(i)
	{	// X1:PC2='H' X2:PC6='L'
		*PCDR0 = (*PCDR0 & 0xFF1B) | 0x0004;
	}
	else
	{	// X1:PC2='L' X2:PC6='H'
		*PCDR0 = (*PCDR0 & 0xFF1B) | 0x0040;
	}

	// X1:PC2 X2:PC6  PC5,PC7:input
	*PCIOR0 = (*PCIOR0 & 0xFF1B) | 0x0044;

}
/****************************************************************
* YɸYŰ
****************************************************************/
void TOUCH_Y1Y2(int i)
{
	if(i)
	{	// Y1:PC5='H' Y2:PC7='L'
		*PCDR0 = (*PCDR0 & 0xFF1B) | 0x0020;
	}
	else
	{	// Y1:PC5='L' Y2:PC7='H'
		*PCDR0 = (*PCDR0 & 0xFF1B) | 0x0080;
	}

	// Y1:PC5 Y2:PC7  PC6,PC2:input
	*PCIOR0 = (*PCIOR0 & 0xFF1B) | 0x00A0;
}
/****************************************************************
* åѥͥ ڥ󸡽
****************************************************************/
int TOUCH_PenDownCheck(void)
{
	int i;

	i = (int)mPCDR0.pc6dr;
	// mPEIOR0.pe3ior = IN;	// PD

	return i;
}
/****************************************************************
* åָ
****************************************************************/
int TOUCH_sta(void)
{
	switch(TOUCH_stat)
	{
		case 0:
			TOUCH_AllHiZ();
			TOUCH_PenDownInitialize();
			TOUCH_stat++;
			break;
		case 1:
			if(TOUCH_PenDownCheck())	// å
				TOUCH_stat++;
				break;
		case 2:
			if(TOUCH_PenDownCheck())
				TOUCH_stat++;
			else
				TOUCH_stat = 0;
			break;
		case 3:
			TOUCH_Y1Y2(1);		// YɸȽ
			TOUCH_stat++;
			break;
		case 4:
			TOUCH_ADstart(0x2002); // A-DѴ(AN0:X -> AN2:X)
			TOUCH_stat++;
			break;
		case 5:
			TOUCH_Ytmp = TOUCH_ADin(2);	// ̼
			TOUCH_stat++;
			break;
		case 6:
			TOUCH_X1X2(1);		// XɸȽ
			TOUCH_stat++;
			break;
		case 7:
			TOUCH_ADstart(0x2001); 	// A-DѴ(AN1:Y)
			TOUCH_stat++;
			break;
		case 8:
			TOUCH_Xtmp = TOUCH_ADin(1);	// ̼(AN1:Y)
			TOUCH_stat++;
			break;
		case 9:
			// ΥΤΤޤǼθΤԤʤ
			TOUCH_AllHiZ();
			TOUCH_PenDownInitialize();
			TOUCH_stat++;
	 		break;
		case 10:
			//  TOUCH_stat > 10 ǥåдλ
			if(TOUCH_PenDownCheck() != 1)	// å
				TOUCH_stat++;
			break;
		default:
			break;
	}
	return TOUCH_stat;
}
