//ƥꥸȥѥȥ  
/***************************************************************
	CPUХ
***************************************************************/
#include "cpu.h"
#include "cpu_init.h"
#include "LCDpanel.h"

/****************************************************************
* DMA ط
****************************************************************/
void	Inidma0(void);
void	Inidma1(void);
void	set_chcr(volatile chcr	*cc);
void	dma_stop(volatile chcr	*cc);
void	dma_reload_set(int ch);

/****************************************************************
*
****************************************************************/
volatile IPRxx	*pIPR01    = (volatile IPRxx  *)0xFFFE0818;
volatile IPRxx	*pIPR02    = (volatile IPRxx  *)0xFFFE081A;
volatile IPRxx	*pIPR05    = (volatile IPRxx  *)0xFFFE0820;
volatile IPRxx	*pIPR06    = (volatile IPRxx  *)0xFFFE0C00;
volatile IPRxx	*pIPR07    = (volatile IPRxx  *)0xFFFE0C02;
volatile IPRxx	*pIPR08    = (volatile IPRxx  *)0xFFFE0C04;
volatile IPRxx	*pIPR09    = (volatile IPRxx  *)0xFFFE0C06;
volatile IPRxx	*pIPR10    = (volatile IPRxx  *)0xFFFE0C08;
volatile stbcr7	*pSTBCR7   = (volatile stbcr7 *)0xFFFE0418;
volatile pfcr2	*pPFCR2    = (volatile pfcr2  *)0xFFFE38AA;
volatile pfcr1	*pPFCR1    = (volatile pfcr1  *)0xFFFE38AC;
volatile pfcr0	*pPFCR0    = (volatile pfcr0  *)0xFFFE38AE;

volatile pbcr5	*pPBCR5    = (volatile pbcr5  *)0xFFFE3824;

volatile cmstr	*pCMSTR    = (volatile cmstr  *)0xFFFEC000;
volatile cmcsr	*pCMCSR_0  = (volatile cmcsr  *)0xFFFEC002;
volatile cmcsr	*pCMCSR_1  = (volatile cmcsr  *)0xFFFEC008;

volatile pccr2	*pPCCR2    = (volatile pccr2  *)0xFFFE384A;
volatile pccr1	*pPCCR1    = (volatile pccr1  *)0xFFFE384C;
volatile pccr0	*pPCCR0    = (volatile pccr0  *)0xFFFE384E;

volatile pcdr0	*pPCDR0    = (volatile pcdr0  *)0xFFFE3856;
volatile pcior0	*pPCIOR0   = (volatile pcior0 *)0xFFFE3852;

volatile pbior1	*pPBIOR1   = (volatile pbior1 *)0xFFFE3830;

volatile pdcr1	*pPDCR1    = (volatile pdcr1  *)0xFFFE386C;
volatile pddr0	*pPDDR0    = (volatile pddr0  *)0xFFFE3876;
volatile pdior0	*pPDIOR0   = (volatile pdior0 *)0xFFFE3872;

volatile frqcr	*pFRQCR    = (volatile frqcr  *)0xFFFE0010;

volatile pwcr	*pPWCR1    = (volatile pwcr   *)0xFFFEF4E0;
volatile pwbfr	*pPWBFR1G  = (volatile pwbfr  *)0xFFFEF4EE;

volatile ushort *pPWCYR1   = (volatile ushort *)0xFFFEF4E6;

volatile pwpr *pPWPR1      = (volatile pwpr   *)0xFFFEF4E4;
volatile pwpr *pPWPR2      = (volatile pwpr   *)0xFFFEF4F4;

volatile pgcr7	*pPGCR7    = (volatile pgcr7  *)0xFFFE38C0;
volatile pgcr4	*pPGCR4    = (volatile pgcr4  *)0xFFFE38C6;
volatile pgcr3	*pPGCR3    = (volatile pgcr3  *)0xFFFE38C8;
volatile pgcr2	*pPGCR2    = (volatile pgcr2  *)0xFFFE38CA;
volatile pgcr1	*pPGCR1    = (volatile pgcr1  *)0xFFFE38CC;
volatile pgcr0	*pPGCR0    = (volatile pgcr0  *)0xFFFE38CE;

volatile pbdr1	*pPBDR1    = (volatile pbdr1  *)0xFFFE3834;
volatile phcr0	*pPHCR0    = (volatile phcr0  *)0xFFFE38EE;
volatile pecr0	*pPECR0    = (volatile pecr0  *)0xFFFE388E;
volatile peior0	*pPEIOR0   = (volatile peior0 *)0xFFFE3892;
volatile pedr0	*pPEDR0    = (volatile pedr0  *)0xFFFE3896;

volatile pjcr0	*pPJCR0    = (volatile pjcr0  *)0xFFFE390E;

volatile stbcr4	*pSTBCR4   = (volatile stbcr4 *)0xFFFE040C;
volatile stbcr3	*pSTBCR3   = (volatile stbcr3 *)0xFFFE0408;
volatile stbcr2	*pSTBCR2   = (volatile stbcr2 *)0xFFFE0018;

volatile pfior0	*pPFIOR0   = (volatile pfior0 *)0xFFFE38B2;
volatile pfdr0	*pPFDR0    = (volatile pfdr0  *)0xFFFE38B6;
volatile adcsr	*pADCSR    = (volatile adcsr  *)0xFFFF9820;

// DMA
volatile dmaor	*pDMAOR    = (volatile dmaor  *)0xFFFE1200;

volatile ulong	*pDMA_SAR_0= (volatile ulong  *)0xFFFE1000;
volatile ulong	*pDAR_0    = (volatile ulong  *)0xFFFE1004;
volatile ulong	*pDMATCR_0 = (volatile ulong  *)0xFFFE1008;
volatile chcr	*pCHCR_0   = (volatile chcr   *)0xFFFE100C;
volatile ulong	*pRSAR_0   = (volatile ulong  *)0xFFFE1100;
volatile ulong	*pRDAR_0   = (volatile ulong  *)0xFFFE1104;
volatile ulong	*pRDMATCR_0= (volatile ulong  *)0xFFFE1108;

volatile ulong	*pDMA_SAR_1= (volatile ulong  *)0xFFFE1010;
volatile ulong	*pDAR_1    = (volatile ulong  *)0xFFFE1014;
volatile ulong	*pDMATCR_1 = (volatile ulong  *)0xFFFE1018;
volatile chcr	*pCHCR_1   = (volatile chcr   *)0xFFFE101C;
volatile ulong	*pRSAR_1   = (volatile ulong  *)0xFFFE1110;
volatile ulong	*pRDAR_1   = (volatile ulong  *)0xFFFE1114;
volatile ulong	*pRDMATCR_1= (volatile ulong  *)0xFFFE1118;

// SCIF 0
volatile scsmr  *pSCSMR_0  = (volatile scsmr  *)0xFFFE8000;
volatile uchar  *pSCBRR_0  = (volatile uchar  *)0xFFFE8004;
volatile scscr  *pSCSCR_0  = (volatile scscr  *)0xFFFE8008;
volatile uchar  *pSCFTDR_0 = (volatile uchar  *)0xFFFE800C;
volatile scfsr  *pSCFSR_0  = (volatile scfsr  *)0xFFFE8010;
volatile uchar  *pSCFRDR_0 = (volatile uchar  *)0xFFFE8014;
volatile scfcr  *pSCFCR_0  = (volatile scfcr  *)0xFFFE8018;
volatile scfdr  *pSCFDR_0  = (volatile scfdr  *)0xFFFE801C;
volatile scsptr *pSCSPTR_0 = (volatile scsptr *)0xFFFE8020;
volatile sclsr  *pSCLSR_0  = (volatile sclsr  *)0xFFFE8024;
volatile scemr  *pSCEMR_0  = (volatile scemr  *)0xFFFE8028;

// VDC3
volatile video_mode      *pVIDEO_MODE       = (volatile video_mode      *)0xFFFF2000;
volatile sgmode          *pSGMODE           = (volatile sgmode          *)0xFFFF3800;
volatile video_save_num  *pVIDEO_SAVE_NUM   = (volatile video_save_num  *)0xFFFF2110;
volatile video_int_cnt   *pVIDEO_INT_CNT    = (volatile video_int_cnt   *)0xFFFF2004;
volatile grcmen          *pGRCMEN1          = (volatile grcmen          *)0xFFFF2800;
volatile grcmen          *pGRCMEN2          = (volatile grcmen          *)0xFFFF3000;
volatile video_size      *pVIDEO_SIZE       = (volatile video_size      *)0xFFFF2100;
volatile video_vstart    *pVIDEO_VSTART     = (volatile video_vstart    *)0xFFFF2104;
volatile video_hstart    *pVIDEO_HSTART     = (volatile video_hstart    *)0xFFFF2108;

volatile video_image_cnt *pVIDEO_IMAGE_CNT = (volatile video_image_cnt *)0xFFFF2114;
volatile video_disp_size *pVIDEO_DISP_SIZE = (volatile video_disp_size *)0xFFFF2128;
volatile panel_clksel    *pPANEL_CLKSEL    = (volatile panel_clksel    *)0xFFFF380C;
volatile syncnt          *pSYNCNT          = (volatile syncnt          *)0xFFFF3808;
volatile grcbuscnt       *pGRCBUSCNT1      = (volatile grcbuscnt       *)0xFFFF2804;
volatile grcbuscnt       *pGRCBUSCNT2      = (volatile grcbuscnt       *)0xFFFF3004;
volatile video_vsync_tim1 *pVIDEO_VSYNC_TIM1 = (volatile video_vsync_tim1 *)0xFFFF210C;

volatile gropewh	 *pGROPEWH1        = (volatile gropewh         *)0xFFFF2B18;
volatile gropewh	 *pGROPEWH2        = (volatile gropewh         *)0xFFFF3318;
volatile gropedphv	 *pGROPEDPHV1      = (volatile gropedphv       *)0xFFFF2B1C;
volatile gropedphv	 *pGROPEDPHV2      = (volatile gropedphv       *)0xFFFF331C;
volatile gropedpa	 *pGROPEDPA1       = (volatile gropedpa        *)0xFFFF2B20;
volatile gropedpa	 *pGROPEDPA2       = (volatile gropedpa        *)0xFFFF3320;

volatile gropswh	 *pGROPSWH1        = (volatile gropswh         *)0xFFFF2B0C;
volatile gropdphv	 *pGROPDPHV1       = (volatile gropdphv        *)0xFFFF2B14;
volatile gropswh	 *pGROPSWH2        = (volatile gropswh         *)0xFFFF330C;
volatile gropdphv	 *pGROPDPHV2       = (volatile gropdphv        *)0xFFFF3314;

volatile syn_size        *pSYN_SIZE        = (volatile syn_size        *)0xFFFF3900;
volatile panel_vsync_tim *pPANEL_VSYNC_TIM = (volatile panel_vsync_tim *)0xFFFF3904;
volatile panel_hsync_tim *pPANEL_HSYNC_TIM = (volatile panel_hsync_tim *)0xFFFF3908;
volatile de_size         *pDE_SIZE         = (volatile de_size         *)0xFFFF3920;
volatile de_start        *pDE_START        = (volatile de_start        *)0xFFFF3924;

/****************************************************************
*
****************************************************************/
void	DMAInitialize(void)
{
	volatile ulong dummy;

	Inidma0();
	Inidma1();

	// DMA ڥ졼쥸DMAOR
	dummy = *xDMAOR;
	mDMAOR.cms  = 0;		//  ̾⡼
	mDMAOR.pr   = 0;		//  ⡼1
	mDMAOR.ae   = 0;		//  ɥ쥹顼ե饰Υꥢ
	mDMAOR.nmif = 0;		//  NMI ե饰Υꥢ
	mDMAOR.dme  = 0;		//  ͥDMA žػ

}
/****************************************************************
*
****************************************************************/
void	Inidma0(void)
{
	int	ch;
	volatile chcr	*cc;

	ch = 0;
	cc = &mCHCR_0;

	dma_stop(cc);

	mDMA_SAR_0 = (ulong)RAM_PAGE5;		// src
	mDAR_0     = (ulong)GRA1_VRAM_BASE;	// dst
	mDMATCR_0  = (GRA1_HORIZONTAL_SIZE 
			* GRA1_VERTICAL_SIZE  / 8); // trans size

	dma_reload_set(ch);
	set_chcr(cc);
}
/****************************************************************
*
****************************************************************/
void	Inidma1(void)
{
	int	ch;
	volatile chcr	*cc;

	ch = 1;
	cc = &mCHCR_1;

	dma_stop(cc);

	mDMA_SAR_1 = (ulong)RAM_PAGE5;		// src
	mDAR_1     = (ulong)RAM_PAGE52; 	// dst

	mDMATCR_1  = (GRA1_HORIZONTAL_SIZE 
			* GRA1_VERTICAL_SIZE  / 8); // trans size

	dma_reload_set(ch);
	set_chcr(cc);
}
/****************************************************************
*
****************************************************************/
void	dma_reload_set(int ch)
{
	switch(ch)
	{
		case 0:
			mRSAR_0    = mDMA_SAR_0;
			mRDAR_0    = mDAR_0;
			mRDMATCR_0 = mDMATCR_0;
			break;
		case 1:
			mRSAR_1    = mDMA_SAR_1;
			mRDAR_1    = mDAR_1;
			mRDMATCR_1 = mDMATCR_1;
			break;
		default:;
	}
}
/****************************************************************
*
****************************************************************/
void	dma_stop(volatile chcr	*cc)
{
	cc->de = 0;
}
/****************************************************************
*
****************************************************************/
void	set_chcr(volatile chcr	*cc)
{
	volatile ulong dummy;

	dummy = *(ulong *)cc;

	cc->tc     = 1;		// TC DMATCR ž1------- DMATCR 
	cc->rldsar = 1;		// SAR Reload on
	cc->rlddar = 1;		// DAR Reload on
	cc->temask = 0;		// 0-------------  TE ӥå=1 ž
	cc->dm     = 1;		// 1-------------  ǥƥ͡󥢥ɥ쥹
	cc->sm     = 1;		// 1-------------  ɥ쥹
	cc->rs     = 4;		// 4-------------  ȥꥯ
	cc->tb     = 0;		// ( 1:Сȥ⡼ɤȲ)
	cc->ts     = 3;		// 3----------  long word * 4ñž
	cc->ie     = 0;		// 0-------------  ߶ػ
	cc->te     = 0;		// 0-------------  TE clear
	cc->de     = 0;		// 0-------------  DMA žػ
}
/****************************************************************
*
****************************************************************/
void	dmaTrans_0(void)
{
	if(mCHCR_0.te == 1)
		mCHCR_0.te = 0;

	if(mDMAOR.nmif == 1)
		mDMAOR.nmif = 0;

	if(mDMAOR.ae == 1)
		mDMAOR.ae = 0;

	// Tranfar start
	mDMAOR.dme = 1;			// DME ӥåȤ
	mCHCR_0.de = 1;			// DMA μ¹ԡDE ӥåȤ

	while( mCHCR_0.te == 0 ){}	// DMA žλԤ
	mCHCR_0.te = 0;
}
/****************************************************************
*
****************************************************************/
void	dmaTrans_1(void)
{
	if(mCHCR_1.te == 1)
		mCHCR_1.te = 0;

	if(mDMAOR.nmif == 1)
		mDMAOR.nmif = 0;

	if(mDMAOR.ae == 1)
		mDMAOR.ae = 0;

	// Tranfar start
	mDMAOR.dme = 1;			// DME ӥåȤ
	mCHCR_1.de = 1;			// DMA μ¹ԡDE ӥåȤ

	while( mCHCR_1.te == 0 ){}	// DMA žλԤ
	mCHCR_1.te = 0;
}
/****************************************************************
* CPUͭ
****************************************************************/
void CPU_BusInitialize()
{
	mPDCR1.pd7md = 2;	// ݡ 2:PWM1H  0:PD7

	// 
	mPFCR2.pf8md = 3;	// DV_CLK
	mPFCR1.pf7md = 3;	// DV_DATA7
	mPFCR1.pf6md = 3;	// DV_DATA6
	mPFCR1.pf5md = 3;	// DV_DATA5
	mPFCR1.pf4md = 3;	// DV_DATA4

	mPFCR0.pf3md = 3;	// DV_DATA3
	mPFCR0.pf2md = 3;	// DV_DATA2
	mPFCR0.pf1md = 3;	// DV_DATA1
	mPFCR0.pf0md = 3;	// DV_DATA0

	// VDC3 
	mPGCR7.H5A    = 0x5a;	// 񤯻 5a餷
	mPGCR7.pg0md  = 1;	// LCD_DATA0

	mPGCR4.pg19md = 1;	// LCD_CLK
	mPGCR4.pg18md = 1;	// LCD_DE
	mPGCR4.pg17md = 1;	// LCD_HSYNC
	mPGCR4.pg16md = 1;	// LCD_VSYNC

	mPGCR3.pg15md = 1;	// LCD_DATA15-12
	mPGCR3.pg14md = 1;
	mPGCR3.pg13md = 1;
	mPGCR3.pg12md = 1;

	mPGCR2.pg11md = 1;	// LCD_DATA11-8
	mPGCR2.pg10md = 1;
	mPGCR2.pg9md  = 1;
	mPGCR2.pg8md  = 1;

	mPGCR1.pg7md = 1;	// LCD_DATA7-4
	mPGCR1.pg6md = 1;
	mPGCR1.pg5md = 1;
	mPGCR1.pg4md = 1;

	mPGCR0.pg3md = 1;	// LCD_DATA3-1
	mPGCR0.pg2md = 1;
	mPGCR0.pg1md = 1;

	mSTBCR7.mstp74 = 0;	// VDC3ؤΥå
	mSTBCR2.mstp8  = 0;	// DMA


	// LCDХå饤ȥ֥͡(PB21(LCD_BLE),)
	mPBCR5.pb21md   = 0;
	mPBIOR1.pb21ior = 1;
	mPBDR1.pb21dr   = 1;
}
/****************************************************************
*
****************************************************************/
void	PWMInitialize(void)
{
	*xPWCR1 = 0xc0;		// PWM /Clock 1/1
	*xPWPR1 = 0x80;		// ops h ȿž
	mPWCYR1 = 632;		// 37974.68354 Hz(-25.3164557)
	*xPWBFR1G = 0xfd0f;
}
/****************************************************************
*	PWM1 :1 :0
****************************************************************/
void	PWM1_cst(int cst)
{
	if(cst == 0)
		*xPWCR1 &= 0xf7;
	else
		*xPWCR1 |= 0x08;
}
/****************************************************************
*	PWM1 
****************************************************************/
void	startPWM1(void)
{
	*xPWCR1 |= 0x08;
}
/****************************************************************
*	PWM1 
****************************************************************/
void	stopPWM1(void)
{
	*xPWCR1 &= 0xf7;
}
/****************************************************************
*  ֳLED ˻Ѥ
****************************************************************/
void	CMT_1_Initialize(void)
{
	//  CMT

	*CMSTR &= 0xfffd;		// CMT 1 

	*mCMCNT_1 = (ushort)0;

	*CMCSR_1 = 0x0041;		// å 11: /512  01:/32

	*mCMCOR_1 = (ushort)64;	

	*CMSTR |= 0x0002;		// CMT 1 ȳ
}
