/************************************************************************/
/* ܥեå롼 إå                                */
/************************************************************************/
#ifndef __GRAPHICS__
#define __GRAPHICS__
#include "IcqcType.h"

#define	ADDX	2	// Хåե̩
#define	ADDX2	1	// Хåե̩

extern const unsigned char FONT_DATA[];		// ASCII 00-7F ե
extern const unsigned long ARROW[];
extern const unsigned short MARK[];

#define	MARK_PLUS	0
#define	MARK_DIA	1
#define	MARK_CAR	2
#define	MARK_SQR	3

/****************************************************************
*	console ѥ᡼
****************************************************************/
typedef struct {
	ushort	*vram;
	int	width;
	int	hight;
	int	fontHight;
	int	fontWidth;
	int	posx;
	int	posy;
	int	col;	// 
	int	row;	// Կ
} Console;

/****************************************************************
*	
****************************************************************/
typedef union {
	ushort	rgb;
	struct {
		ushort	r	:5;
		ushort	g	:6;
		ushort	b	:5;
	} rgb565;
} color;


void	initConsole(Console *con,int width,int height,unsigned short *vram);
void	Con_fill(Console *con,ushort col);
void	GCON_put_gryph(int c ,int x,int y,unsigned short *gram,int ww);

void	CON_locate(Console *con,int x,int y);
void	CON_puts(Console *con,char *str);
void	CON_ptn(Console *con,int code,int x,int y);
void	CON_mark(Console *con,int code,int x,int y,ushort col);

void	dispNum(Console *con,int x,int y,int num,int k,int d);	// ɽ
void	dispStr(Console *con,int x,int y,char *str);		// ʸɽ


void	scrolle(Console *con);


void	makeGrCntTbl(void);		// Ѵơ֥
ushort 	rgb2gr(color *rgb);		// 졼Ѵ
void	bwCnv(void);			// ɽ vram Ƥ bw Ѵ
void	cq_find(int *,int *);		// Q 
short	Scan(ushort *x,short max);	// 󸡺

void	gram2fill(void);

char	*numToStr(int n,char *buf,int k,int d);		// ʸѴ

#endif
