#include <t_services.h>

/*
 *  ƥͥ٤
 */

#define MAIN_PRIORITY	5		// ᥤ󥿥ͥ 
					// HIGH_PRIORITY ⤯뤳 

#define HIGH_PRIORITY	9		// ˼¹Ԥ륿ͥ
#define MID_PRIORITY	10
#define LOW_PRIORITY	11

/*
 *  åȰ¸CPU㳰ϥɥεưˡʤɡ
 */

#ifdef M68K

#define CPUEXC1		5		/* 㳰 */
#define RAISE_CPU_EXCEPTION	syslog(LOG_NOTICE, "zerodiv = %d", 10 / 0)

#elif defined(SH3)

#define CPUEXC1		224		/* ɥ顼㳰 */
#define RAISE_CPU_EXCEPTION	(*((volatile int *) 0xFFFFFEC1))

#elif defined(SH1)

#define CPUEXC1		9		/* CPUɥ쥹顼㳰 */
#define RAISE_CPU_EXCEPTION	(*((volatile int *) 0xFFFFFEC1))
#ifdef TOKIWA_SH1
#define	STACK_SIZE	512		/* Υå */
#endif /* TOKIWA_SH1 */

#elif defined(ARMV4)

#define CPUEXC1		4		/* ɥ顼㳰 */
#define RAISE_CPU_EXCEPTION	(*((volatile int *) 0xFFFFFEC1))

#elif defined(V850)

#elif defined(H8)

#undef CPUEXC1				/* CPU㳰ϥɥ򥵥ݡȤʤ */

#elif defined(H8S)

#undef CPUEXC1				/* CPU㳰ϥɥ򥵥ݡȤʤ */
#define LOOP_REF	4000L		/* ®ٷ¬ѤΥ롼ײ */

#elif defined(MICROBLAZE)

#undef CPUEXC1				/* CPU㳰ϥɥ򥵥ݡȤʤ */
#define STACK_SIZE	2048		/* Υå */

#elif defined(IA32)

#define CPUEXC1		0		/* 㳰 */
#define RAISE_CPU_EXCEPTION   syslog(LOG_NOTICE, "zerodiv = %d", 10 / 0)
#define OMIT_VGET_TIM

#elif defined(TMS320C54X)

#undef CPUEXC1				/* CPU㳰ϥɥ򥵥ݡȤʤ */
#define STACK_SIZE	320		/* Υå */
#define LOOP_REF	500000L		/* ®ٷ¬ѤΥ롼ײ */

#elif defined(XSTORMY16)

#define CPUEXC1		0		/* ̵̿㳰 */
#define RAISE_CPU_EXCEPTION	__asm__( ".hword 0x0006" )
#define OMIT_VGET_TIM			/* vxget_tim()󥵥ݡ */
#define LOOP_REF 	4000L		/* ®ٷ¬ѤΥ롼ײ */
#define STACK_SIZE	256		/* Υå */
#define TASK_PORTID	1		/* SIOϥݡ1Ѥ */

#elif defined(MIPS3) || defined(MIPS64)

#define CPUEXC1     Bp      /* ֥졼ݥ㳰ʥȯ */
#define RAISE_CPU_EXCEPTION   syslog(LOG_NOTICE, "zerodiv = %d", 10 / 0)

#elif defined(M16C) && defined(OAKS16)

#define CPUEXC1     32      /* CPU㳰ϥɥֹ */
#define RAISE_CPU_EXCEPTION asm("   int #32") /* եȥȯ */
#define STACK_SIZE  512     /* Υå */
#define TASK_PORTID 2       /* ʸϤ륷ꥢݡID */

#elif defined(M16C) && defined(OAKS16_MINI)

#define CPUEXC1     32      /* CPU㳰ϥɥֹ */
#define RAISE_CPU_EXCEPTION asm("   int #32") /* եȥȯ */
#define STACK_SIZE  384     /* Υå */
#define TASK_PORTID 2       /* ʸϤ륷ꥢݡID */

#elif defined(M16C) && defined(M3029) 

#define CPUEXC1     32      /* CPU㳰ϥɥֹ */
#define RAISE_CPU_EXCEPTION asm("   int #32") /* եȥȯ */
#define STACK_SIZE  512     /* Υå */
#define TASK_PORTID 1       /* ʸϤ륷ꥢݡID */

#elif defined(LINUX)

#undef CPUEXC1				/* CPU㳰ϥɥ򥵥ݡȤʤ */
#define OMIT_VGET_TIM
#define LOOP_REF	4000000		/* ®ٷ¬ѤΥ롼ײ */

#elif defined(NIOS2)

#define CPUEXC1		0		  /* ̤̿㳰 */
#define RAISE_CPU_EXCEPTION	  Asm("div zero, zero, zero");

#elif defined(M32C)

#define CPUEXC1 32 /* CPU㳰ϥɥֹ */
#define RAISE_CPU_EXCEPTION asm(" int #32") /* եȥȯ */
#define STACK_SIZE 512 /* Υå */
#define TASK_PORTID 1 /* ʸϤ륷ꥢݡID */ 

#elif defined(M32R)

#define CPUEXC1 EXC_TRAP00
#define RAISE_CPU_EXCEPTION Asm("trap 0")

#elif defined(TLCS_900) && defined(ZUP_F16_EX)

#define CPUEXC1     3      /* CPU㳰ϥɥֹ */
#define RAISE_CPU_EXCEPTION Asm("   swi 2") /* եȥȯ */
#define STACK_SIZE  512     /* Υå */
#define TASK_PORTID 1       /* ʸϤ륷ꥢݡID */
#define OMIT_VGET_TIM

#elif defined(__lm32__)

#define CPUEXC1              5 
#define RAISE_CPU_EXCEPTION  syslog(LOG_NOTICE, "zerodiv = %d", 10 / 0)
#define STACK_SIZE           512 
#define LOOP_REF	         500000

#endif

/*
 *  åȤ˰¸ǽΤ
 */

#ifndef TASK_PORTID
#define	TASK_PORTID	1		/* ʸϤ륷ꥢݡID */
#endif /* TASK_PORTID */

#ifndef STACK_SIZE
#define	STACK_SIZE	8192		/* Υå */
#endif /* STACK_SIZE */

#ifndef LOOP_REF
#define LOOP_REF	1000000		/* ®ٷ¬ѤΥ롼ײ */
#endif /* LOOP_REF */

/*
 *  ؿΥץȥ
 */
#ifndef _MACRO_ONLY

extern void	taskCq(VP_INT tskno);
extern void	taskTp(VP_INT tskno);
extern void	main_task(VP_INT exinf);
extern void	tex_routine(TEXPTN texptn, VP_INT tskno);
extern void	cyclic_handler(VP_INT exinf);
extern void	cpuexc_handler(VP p_excinf);

extern void	funcFLDE(void);
extern void	funcCMT_1(void);


#endif /* _MACRO_ONLY */
