#include <t_services.h>
#include <s_services.h>

#include "drive.h"
#include "graphics.h"		// ܥեå롼إå
#include "LCDpanel.h"
#include "TouchPanel.h"
#include "cpu_init.h"		// CPUͭإå

#define	TURN_RIGHT	0
#define	TURN_LEFT	1

#define	FORWARD		0
#define	REVERS		1


#define	INIT	1
#define	RUN	0

#define	PRANGE	20	// permissible range 

extern Console	con2;	// 󥽡
static int	absx(int x,int y);		// ʬ׻
static int	getPosition(int *px,int *py);	// ֤߰μ
static int	isHit(int xx,int yy);
static int	judge(int sx,int sy,int px,int py);

inline int	getPosition0(int *px,int *py);


int	smove(int ,int *,int *);	// äư
int	smove_v(int ,int *,int *,int);	// äư
int	sturn(int vect,int *x,int *y);

/****************************************************************
*	ž
*	ָФʤʤ
*
*	out	1	
*		2	Goal 
****************************************************************/
int	sturn(int vect,int *x,int *y)
{
	int	ret;
	static	int	fwd[] = {CM_F_RIGHT, CM_F_LEFT};
	static	int	bk[]  = {CM_B_LEFT , CM_B_RIGHT};


	ret = smove_v(fwd[vect],x,y,25);

	if(ret != 2)
		ret = smove_v(bk[vect],x,y,20);


	dly_tsk(200);

	return ret;
}
/****************************************************************
*	Ȱư
*
*	ϤߤǤʾθФǤʤ
*	
*	in	cmd	ưޥ
*		px,py	ߤκɸϤ κɸΰư̤򸡽Фưưλꤹ
*			ưλߤκɸåȤ
*
*	out	0	ָФǤʤ
*		1	ưưָФ
*		2	Goal 
****************************************************************/
#define	MOVE_VOL	20
int	smove(int cmd,int *x,int *y)
{
	return smove_v(cmd,x,y,MOVE_VOL);
}
/****************************************************************
*	ư̻
*	out	1	̰ư
*		2	Goal 
****************************************************************/
int	smove_v(int cmd,int *x,int *y,int move_vol)
{
	int	px0,py0;	// Ϥ˸Ф
	int	py,px;

	int	ret;
	int	vol;

	ret = 1;

	px0 = *x;
	py0 = *y;


	// äȰư
	while(1)
	{
		cqCmd(cmd);
		dly_tsk(100);
		cqCmd(0);
		dly_tsk(10);

		while(getPosition(&px,&py)==0)	// Ĥʤȴʤ
			dly_tsk(1);

		// Goal Ƚꤹ
		if(isHit(px,py) == 1)
		{
			ret = 2;
			break;
		}

		// ֤Ȥκ顢إ˶ŤƤ
		// Фä顢ưλ

		if((px != px0)||(py != py0))
		{
			vol = absx(px,px0) + absx(py,py0);
			dispNum(&con2,19,5,vol  ,4,10);
			if(vol > move_vol)
				break;
		}
	}
	*x = px;
	*y = py;

	return ret;
}
/****************************************************************
*	
*	1.ָ
*	2.
*	3.ž
*	out	0	Goal
*		-1	Not Goal
****************************************************************/
int	toGoal(int *goalStep)
{
	static	int	px0 = 0;	// Ϥ˸Ф
	static	int	py0 = 0;
	static	int	px1 = 0;	// ˸Ф
	static	int	py1 = 0;
	static	int	v = 0;
	int	i;
	int	ret;

	ret = -1;

	dispStr(&con2, 4,3,"st");
	dispNum(&con2, 7,3,*goalStep ,4,10);	// step

	switch(*goalStep)
	{
		case 0:		// ֤߰μ
			if(getPosition(&px0,&py0))
			{
				dispStr(&con2, 4,4,"p0");
				dispNum(&con2, 7,4,px0 ,4,10);
				dispNum(&con2,13,4,py0 ,4,10);

				// TOUCH_X ,TOUCH_Y Ȥ
				if(isHit(px0,py0) == 1)
				{
					(*goalStep)=0;
					ret = 0;
					syslog(LOG_NOTICE, "=Hit=");
				}
				else
					(*goalStep)++;
			}
			break;
		case 1:		// ưư֤򸡽Ф
			i = smove_v(CM_FWD,&px1,&py1,10);
			if(i == 2)
			{
				(*goalStep)=0;
				ret = 0;
			}
			else
				(*goalStep)++;
			break;
		case 2:	// žȽ
			v = judge(px0,py0,px1,py1);	// ٥ȥ뤫ư٤򸡽Ф
			switch(v)
			{
				case  1:
					i = smove_v(CM_FWD,&px1,&py1,10);
					break;
				case  -2:
					i = sturn(TURN_RIGHT,&px1,&py1);
					break;
				case  2:
					i = sturn(TURN_LEFT,&px1,&py1);
					break;
				default:;
			}
			(*goalStep)=0;

			if(i == 2)
				ret = 0;
			break;
		default:;
	}

	return ret;
}
/****************************************************************
*	in	sx,sy	
*		px,py	Q θ߰
*	out	0	hit
*		-2	turn right
*		2	turn left
*		1	ľ
****************************************************************/
int	judge(int sx,int sy,int px,int py)
{
	int	ret;
	int	yy;
	int	zz;
	int	vect_t;	// å֤ sy 
	int	vect_p;	// å֤ sy 


	// Hit Ƚ
	if(isHit(px,py) == 1)
	{
		ret = 0;
	}
	else
	{
		vect_t = ((TOUCH_Y- sy) > 0) * 2 - 1;	// sy  (1 or -1) 
		vect_p = ((py - sy) > 0) * 2 - 1;	// sy  (1 or -1) 

		if(absx(TOUCH_X,sx) < PRANGE)	// y˥åݥȤ
		{

			if(absx(TOUCH_X,px) < PRANGE)	// y˥Q¸
			{
				// TOUCH_Y > py > sy δطˤʤäƤ
				if((TOUCH_Y - py)*vect_t > 0 && (py - sy)*vect_t > 0)
					ret = 1;	// ˥åȤ
				else
				{
					if(sx < GRA1_HORIZONTAL_SIZE/2)
						ret = -2 * vect_p;
					else
						ret = 2  * vect_p;
				}
			}
			else	// y̵
			{
				if(sx > px)
					ret = -2;
				else
					ret = 2;
			}
		}
		else
		{
			yy = ((TOUCH_Y  - sy) * (px-sx)) / (TOUCH_X  - sx);
			zz = yy + sy - py;
			if(zz== 0)
			{
				if(sy < py)
					ret = 0;
				else
				{
					if(px < GRA1_HORIZONTAL_SIZE/2)
						ret = -2;
					else
						ret = 2;
				}
			}
			else
			{
				if(zz < 0)
				{
					if(sx < TOUCH_X)
						ret = -2;
					else
						ret = 2;
				}
				else
				{
					if(sx < TOUCH_X)
						ret = 2;
					else
						ret = -2;
				}
			}
		}
	}
	return ret;
}
/****************************************************************
*	Hit Ƚ
*	in	xx,yy	å֤ȤӺɸ
*	out	1	Hit
*		0	Not Hit
****************************************************************/
int	isHit(int xx,int yy)
{
	int	z0,z1,ret;

	// Hit Ƚ
	z0 = absx(TOUCH_X , xx);
	z1 = absx(TOUCH_Y , yy);

	if((z0 < PRANGE) && (z1 < PRANGE))
		ret = 1;
	else
		ret = 0;
	return ret;
}
/****************************************************************
*
****************************************************************/
int	getPosition(int *px,int *py)
{
	int	ox,oy;
	int	ret;

	ox = cq_pos_x;
	oy = cq_pos_y;

	doGetImage=1;		// RAM žå
	while(doGetImage==1)
		dly_tsk(1);

	if(cq_pos_x != -1)
	{
		ret = 1;
		if((ox != cq_pos_x)||(oy != cq_pos_y))
		{
			CON_mark(&con2,MARK_SQR,ox,oy,0);	// õ
			CON_mark(&con2,MARK_CAR,cq_pos_x,cq_pos_y,0x0fff);
		}
	}
	else
	{
		if(ox != -1)
			CON_mark(&con2,MARK_SQR,ox,oy,0);	// õ
		ret = 0;
	}

	dispStr(&con2, 4,5,"p1");
	dispNum(&con2, 7,5,cq_pos_x ,4,10);
	dispNum(&con2,13,5,cq_pos_y ,4,10);

	*px = cq_pos_x;
	*py = cq_pos_y;

	return ret;
}
/****************************************************************
*
****************************************************************/
inline int	getPosition0(int *px,int *py)
{
	int	ret;

	doGetImage=1;		// RAM žå
	while(doGetImage==1)
		dly_tsk(1);

	if(cq_pos_x != -1)
		ret = 1;
	else
		ret = 0;

	*px = cq_pos_x;
	*py = cq_pos_y;

	return ret;
}
/****************************************************************
*	
****************************************************************/
int	absx(int x,int y)
{
	int	z;
	z = x-y;
	z *= ((z<0) * -2) + 1;
	return z;
}
