/************************************************************************
* 
************************************************************************/
#include "cpu.h"	// ܥեå롼إå
#include "graphics.h"	// ܥեå롼إå
#include "LCDpanel.h"	// LCDѥͥ롼إå

static ushort	gr1[160 * 120];	// bw Ѵ

static ushort grCnvTbl[128];	// 졼Ѵơ֥

#define	BORDER		4	// ƤȽꤹǻ
#define	LUMP_MIN	3	// Ƚꤹ륵 -1
#define	LUMP_MAX	15	// Ƚꤹ륵 -1

/****************************************************************
* QѲɽ
****************************************************************/
void	gram2fill(void)
{
	ushort *gram;
	int	i,j,x;

	x = 0;
	for(j=0;j<GRA1_VERTICAL_SIZE;j+=2)
	{
		gram=(ushort *)(GRA2_VRAM_BASE + (GRA1_HORIZONTAL_SIZE * sizeof(short) * j));
		for(i=0;i<GRA1_HORIZONTAL_SIZE;i+=2)
		{
			gram[i] = gr1[x++];
		}
	}
}
/****************************************************************
*  Q ָ
*	¸ߤɸ򸡺
*	in	cpx,cpy	̤Ǽ
*			нʤä硢ͤ -1 ˤʤ롣
****************************************************************/
void	cq_find(int *cqx,int *cqy)
{
	ushort *gram;
	short	y[120];
	short	x[160];
	short	i,j,k;
	short	col;

	for(i=0;i<120;i++)
		y[i]=0;

	for(i=0;i<160;i++)
		x[i]=0;

	// x,y αٿ
	k=0;
	for(j=0;j<120;j++)
	{
		for(i=0;i<160;i++)
		{
			col = (gr1[k++] == 0);
			x[i] += col;
			y[j] += col;
		}
	}

	*cqx = (int)(Scan(x,160) * 2);
	*cqy = (int)(Scan(y,120) * 2);

	// ̤ץåȤ
	k=0;
	for(j=0;j<GRA1_VERTICAL_SIZE;j+=2)
	{
		gram=(ushort *)(GRA2_VRAM_BASE + (GRA1_HORIZONTAL_SIZE * sizeof(short) * j));
		if(y[k++] > BORDER)
			gram[319] = 0x07e0;
		else
			gram[319] = 0;
	}

	k=0;
	gram=(ushort *)(GRA2_VRAM_BASE + (GRA1_HORIZONTAL_SIZE * sizeof(short) * 239));
	for(i=0;i<GRA1_HORIZONTAL_SIZE;i+=2)
	{
		if(x[k++] > BORDER)
			gram[i] = 0x07e0;
		else
			gram[i] = 0;
	}
}
/****************************************************************
*	ꤷ󤫤֤򸡽Ф
*	in	x	ĤޤꡢƸٿǼ
*		max	x Υ
*
*	out	!= -1	
*		-1	̵
****************************************************************/
short	Scan(ushort *x,short max)
{
	short	kk,ss,kt,st,i;

	// tmp
	kt=0;
	st=-1;

	// 
	kk = 0;
	ss = -1;

	for(i=0;i<max;i++)
	{
		if(x[i] > BORDER)
		{
			if(i == (st+kt))// ⤷Ϥä
				kt++;	// ȥå
			else
			{
				st = i;	// 
				kt = 1;	// ֤
			}
		}
		else
		{
			// Ƚ(θͤ򹹿롣
			if((kt > LUMP_MIN)&&(kt < LUMP_MAX))	// Ƚ
			{
				if(kk != 0)
					return -1;	// ˲
				else
				{
					kk = kt;
					ss = st;
				}
			}
			kt = 0;
			st = 0;
		}
	}

	// ǽȽ
	if((kt > LUMP_MIN)&&(kt < LUMP_MAX))	// Ƚ
	{
		if(kk != 0)
			return -1;
		else
		{
			kk = kt;
			ss = st;
		}
	}
	return (ss+kk/2);
}
/****************************************************************
*	ɽ bw Ѵ
*	ΤӤѴ̵
****************************************************************/
void	bwCnv(void)
{
	int	i,j,x;
	ushort *gram;

	x=0;

	for(j=0;j<GRA1_VERTICAL_SIZE;j+=2)
	{
		gram=(ushort *)(RAM_PAGE52 + (GRA1_HORIZONTAL_SIZE * sizeof(short) * j));
		for(i=0;i<GRA1_HORIZONTAL_SIZE;i+=2)
		{
			gr1[x++] = rgb2gr((color *)&gram[i]);
		}
	}
}
/****************************************************************
*	Ѵơ֥
****************************************************************/
void	makeGrCntTbl()
{
	ushort	i;
	ushort	xx;
	ushort	gr;

	for(i=0;i<128;i++)
	{
		xx = i * 32;
		gr = xx / 0x7e;
		if(gr < 9)
			gr = 0;
		else
			gr = 31;
		grCnvTbl[i] = gr;
	}
}
/****************************************************************
*	졼Ѵ
****************************************************************/
ushort 	rgb2gr(color *rgb)
{
	color	gg;
	ushort	gr;

	gr = grCnvTbl[((rgb->rgb565).r + (rgb->rgb565).g + (rgb->rgb565).b)];	// Ѵ

	gg.rgb565.r = gr;
	gg.rgb565.g = gr;
	gg.rgb565.b = gr;

	return gg.rgb;
}
/****************************************************************
*	ɤĤ֤
****************************************************************/
void	Con_fill(Console *con,ushort col)
{
	int	i,j;
	ushort	*vram;

	vram = con->vram;

	for(j=0;j<con->hight;j++)
	{
		for(i=0;i<con->width;i++)
			*vram++ = col;
	}
}
/****************************************************************
*
****************************************************************/
void	scrolle(Console *con)
{
	unsigned short *s,*d;
	int	x,y,i;

	d = con->vram;
	s = con->vram + con->width * 16;

	for(y=con->fontHight;y<con->hight;y++)
	{
		for(x=0;x<con->width;x++)
			*d++ = *s++;
	}

	y = con->hight/con->fontHight-1;
	x = con->width/con->fontWidth;

	for(i=0;i<x;i++)
		GCON_put_gryph((int)' ' ,i,y,con->vram,con->width);

}
/****************************************************************
*	ʸɽ
****************************************************************/
void	GCON_put_gryph( int c ,int xx,int yy,unsigned short *gram,int gwidth)
{
	int	x, y;
	uchar	b;
	uchar	*ft;
	ushort	g;

	gram += (gwidth * 16 * yy);
	gram += (xx * 8);

	// պ
	ft	= (unsigned char *)&FONT_DATA[ c * 16 ];
	for( y = 0; y < 16; y++ )
	{
		b = ft[y];
		for( x = 0; x < 8; x++ )
		{
			if( b & 0x80 )
				g = 0xffff;	// col_fg;
			else
				g = 0x0;	// col_bg;
			b <<= 1;

			gram[x] = g;
		}
		gram += gwidth;
	}
}
/****************************************************************
*	ѥ 32x32 ˤ뤫
*	in	con	Console
*		code	饯ֹ
*		x,y	ɽϺɸ
****************************************************************/
void	CON_ptn(Console *con,int code,int x,int y)
{
	unsigned short	*vram;
	int	i,j,z;
	unsigned long q;
	int	cd;


	cd = code * 32;

	vram = con->vram + con->width * y;
	// ARROW[] 
	for(j=0;j<32;j++)
	{
		q=0x80000000;
		for(i=0;i<32;i++)
		{
			z = (0 != (ARROW[j+cd] & q));
			vram[i+x] = z * 0xffff;
			q >>= 1;
		}
		vram += con->width;
	}
}
/****************************************************************
*	ѥ 16x16 ˤ뤫
*	in	con	Console
*		code	饯ֹ
*		x,y	ɽϺɸ(ɤ餫'-' Ȳ⤷ʤ)1e
*		col	ɽ
****************************************************************/
void	CON_mark(Console *con,int code,int x,int y,ushort col)
{
	ushort	*vram;
	int	i,j,z;
	ushort	q;
	int	cd;

	if((x < 0)||(y < 0))
		return;

	y = 240 -y;
	cd = code * 16;

	vram = con->vram + con->width * y;

	// MRRK[] 
	for(j=0;j<16;j++)
	{
		q=0x8000;
		for(i=0;i<16;i++)
		{
			z = (0 != (MARK[j+cd] & q));
			vram[i+x] = z * col;
			q >>= 1;
		}
		vram += con->width;
	}
}
/****************************************************************
*
****************************************************************/
void	CON_puts(Console *con,char *str)
{
	int	i;
	int	x;

	i=0;
	x = con->posx;
	while(*str != 0)
	{
		GCON_put_gryph((int)(*str++),x++,con->posy,con->vram,con->width);
	}

}
/****************************************************************
*
****************************************************************/
void	initConsole(Console *con,int width,int hight,unsigned short *vram)
{
	con->vram  = vram;
	con->width = width;
	con->hight = hight;
	con->posx  = con->posy = 0;
	con->fontHight=16;
	con->fontWidth=8;

	con->col = width / con->fontWidth;
	con->row = hight / con->fontHight;
}
/****************************************************************
*
****************************************************************/
void	CON_locate(Console *con,int x,int y)
{
	con->posx = x;
	con->posy = y;
}
/****************************************************************
*	ɽ
*	in	con	Consle
*		x,y	ɸ
*		num	ɽ
*		k	
*		d	dʿ
****************************************************************/
void	dispNum(Console *con,int x,int y,int num,int k,int d)
{
	char	buf[10];

	buf[k]=0;
	numToStr(num,buf,k,d);

	dispStr(con,x,y,buf);

}
/****************************************************************
*	ʸɽ
*	in	con	Consle
*		x,y	ɸ
*		str	ɽ
****************************************************************/
void	dispStr(Console *con,int x,int y,char *str)
{
	CON_locate(con,x,y);
	CON_puts(con,str);
}
/****************************************************************
*	10Ѵ						*
*	-פν						*
*	ͤʸѴ塢Ƭˡ-פդ롣		*
*	Ĥޤꡢ餫ͤ¸ߤƤ񤯡			*
*	in	n	10ѴƷ̤buf	*
*		buf						*
*		k	(Default: 2)			*
*		d	dѴ(2-35)				*
*								*
*	out	buf						*
*						March-95	*
*						m.yamaura	*
****************************************************************/
char	*numToStr(int n,char *buf,int k,int d)
{
	short	a,i,j;
	short	fugo;

	static char tbl[]={
			'0','1','2','3','4','5','6','7','8','9',
			'A','B','C','D','E','F','G','H','I','J',
			'L','M','N','O','P','Q','R','S','T','U',
			'V','W','X','Y','Z'
	};

	fugo = (n < 0) * -2 + 1;

	n *= (int)fugo;

	for(i=0;i<k;i++)		// 
		buf[i]='0';
	j=k-1;
	for(i=0;i<k;i++)
	{
		a=n % d;
		n /= d;
		buf[j--]=tbl[a];
		if(n==0)
			break;
	}
	if(fugo == -1)
		buf[0]='-';
	return(buf);
}
