#include <t_services.h>
#include <s_services.h>
#include "cpu.h"
#include "cpu_init.h"
#include "led.h"
#include "graphics.h"
#include "drive.h"


LedPtnDat	ledPtnList[16];	// ⥳ѥ
LedPtnDat	*ledPtn;

extern short	ledCnt;	// ⥳ѥ
extern Console	con2;		// 󥽡
extern int	sec;

void	ledPtnSet(char band,int cmdCd,LedPtnDat *lpd);

/****************************************************************
*
****************************************************************/
void	led(int LED_flag)
{
	mPCDR0.pc8dr   = LED_flag;	// ǡå(LED)
}
/****************************************************************
*	⥳ư
*	ư
*	
*	Υǡλ뤳ȤԤư˰ܤ
****************************************************************/
void	cqCmd(int cmdCd)
{
	// ledPtn.sendEnd = 1;		// ⥳
	// while(ledCnt != 0)		// ޥɽλԤ
	// 	dly_tsk(1);

	// λ
	ledCnt = 0;

	// ledPtnSet(band,cmdCd,&ledPtn);	// ޥ
	ledPtn = &ledPtnList[cmdCd];	// ޥɥå


	CON_ptn(&con2,cmdCd,10,20);	// ޥɥɽ
	ledPtn->sendEnd = 0;		// ³

	// ߥޥ cmdCd == 0
	if(cmdCd == 0)
		ledPtn->sendEnd = 1;	// ⥳ѥ

	ledCnt = 1;			// ޥɼ¹
}
/****************************************************************
*	for LED Remote control
*	( 100 micro Ĥޤꡢ10000 Ȥǡ1sec)
****************************************************************/
void	funcCMT_1(void)
{
	static	int	sec_c = 0;

	*CMCSR_1 &= 0xff7f;	// cmf = 0

	if(sec_c++ > 9999)
	{
		sec_c=0;
		sec++;
	}

	if(ledCnt == 0)
	{
		PWM1_cst(0);
		return;
	}

	if(ledCnt < ledPtn->dlen)
		PWM1_cst(ledPtn->led[ledCnt] - '0');
	else
	{
		if(ledCnt == ledPtn->dlen)	// λ
			PWM1_cst(0);
		else				// delay
		{
			if(ledCnt >= ledPtn->cycle)
			{
				if(ledPtn->sendEnd == 1)
				{
					ledPtn->sendEnd = 0;
					ledCnt = -1;	// λ
				}
				else
					ledCnt = 0;	// 
			}
		}
	}
	ledCnt++;
}
/****************************************************************
*ޥɥå
* ХɤȡޥɤLEDȯѥǡ롣
*	in	band A: "00"
*		     B: "01"
*		     C: "10"
*		     D: "00"
****************************************************************/
void	ledPtnSet(char band,int cmdCd,LedPtnDat *lpd)
{
	short	i,j;
	short	dlen;
	char	*led;
	char	*buf;
	char	*cmd;

	static char	*ptn[] = {
			"000001111.",		// 0
			"00000111111111."	// 1
	};
	static char	*bnd[] = { "00","01","10","11" };	// A B C D

	// ޥɴdelay  A:9[ms]  B:25[ms] C:41[ms] D:57[ms]
	static  short	delay[] = { 9, 25, 41, 57};

	const char *cmdx[] = {
		"1111",		// stop
		"0001",		// 		1	*
		"0010",		// 		2	*
		"0011",		// 		3
		"0100",		// 		4
		"0101",		// 		5
		"0110",		// 		6	*
		"0111",		// 		7	*
		"1000",		// 		8
		"1001",		// 		9
		"1010",		// 		10	*
		"1011",		// 		11	*
		"1100",		// 		12
		"1101",		// 		13
		"1110",		// 		14
		"1111"		// 		15
	};

	cmd = (char *)cmdx[cmdCd];

	led = lpd->led;
	dlen = 0;

	for(j=0;j<2;j++)
	{
		for(i=0;i<20;i++)
		{
			*(led++) = '1';
			dlen++;
		}
		// band
		for(i=0;i<2;i++)
		{
			buf = ptn[(bnd[band-'A'])[i]-'0'];
			while(*buf != 0)
			{
				*led++ = *buf++;
				dlen++;
			}
		}
		// cmd
		for(i=0;i<4;i++)
		{
			buf = ptn[cmd[i]-'0'];
			while(*buf != 0)
			{
				*led++ = *buf++;
				dlen++;
			}
		}
		for(i=0;i<(delay[band -'A'] * 1000 / 100);i++)	// (9ms * 1000)s/100(ֳ)
		{
			*(led++) = '0';
			dlen++;
		}
	}
	lpd->dlen  = dlen;
	lpd->cycle = 1340;	// Icqc
	// lpd->cycle = 1300;	// Icqc
}
